# Create a New Trait Template

### Creating a Trait Template for NFTs

Follow these steps to create a Trait Template:

#### 1. Create a new JSON file

Open a JSON editor such as Visual Studio Code or Sublime Text, and create a new JSON file. Alternatively, you can start with our sample JSON file.

{% file src="/files/I9LUwnnQPwKR2yefguYc" %}

#### 2. Fill in trait information

Traits must be represented as objects with the following attributes:

* `value`: This field represents the value or title of the Trait (e.g., 'Background 1' or 'Sunglasses').
* `trait_type`: This field defines the type of the trait and is used to group a series of traits under one category. On NFT Marketplaces, the `trait_type` is displayed as Attributes.
* `renderOrder`: This field specifies the order in which the trait should be rendered. For instance, `renderOrder` 0 will not show up visually on the NFT, while `renderOrder` 1 is typically the Background, and so on.
* `imageUrl`: This field provides a URL to an image of the trait, such as a background or an accessory. Learn how to generate the `imageUrl` in the Media Upload section of our documentation.

Here's an example of a unique trait in JSON code, including an `imageUrl` field that points to an image hosted on Arweave:

```json
{
  "value": "Background 02",
  "trait_type": "Background"
  "render_order": "1"
  "image_url": "ar://PHVlm5NP_cmlKB9SPWymrnYxa4DOUs935yrCvlf1c_c",
  "original_minter_royalty_bips": "200",
  "artist_royalty_bips": "200",
  "artist_address": "0x956fefb316a11fa5b528f1fe0eee2b2e2e62ae60",
  "original_minter_address": "0x7b7ec6cfa269d17f8484fd031748d80929f96491",
},
```

#### 3. Add traits to your collection

Add as many traits as needed for your collection. There is no limit to the number of traits that can be included in a Trait Template.

#### 4. Save and upload the JSON file

Save the JSON file and upload it to the Degen Engine Trait Template submission page, or send it to the API.

After following these steps, you're ready to begin minting traits.

{% content-ref url="/pages/duXHPDCOCugESo4L15C9" %}
[Minting New Traits](/degen-engine/guides/minting-new-traits.md)
{% endcontent-ref %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.playground.ooo/degen-engine/guides/trait-templates/create-a-new-trait-template.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
